#include "m_extern.h"
#include <math.h>

/*************** jimbob **************************/

#define DIM 88
#define GOO 8
#define COLS (DIM + GOO)
#define FIRST 21
#define LAST (FIRST + DIM)

struct trans
{
  unsigned char t_vel;
  unsigned char t_length;
  unsigned short t_inter;
};
struct hang
{
  struct trans *h_trans;
  long h_time;
};
typedef struct jimbob
{
  struct object m_ob;
  struct trans **m_matrix;
  int m_recpit;
  int m_restart;
  long m_rectime;
  struct hang m_hang[DIM];
  char m_goophase[DIM];
  struct trans m_firsttrans;
  int m_firstpit;
  int m_playpit;
  struct trans *m_playtrans;
  
  void *m_clock;
  void *m_velout;
  void *m_durout;
  long m_val;
  long m_maxdiff;
  long m_record;
  long m_inval;
  long m_repeat;
  int m_chordlength;
} t_jimbob;

long state;
randi(void)
{
  state = state * 210427233L + 1489352071L;
  return ((state >> 16) & 0x7fff);
}

void jimbob_int(struct jimbob *m, long int x1)
{
  long x2;
  int lastrec;
  long timediff;
  
  x2 = m->m_inval;
  lastrec = m->m_recpit;
  if (!m->m_record)
    {
      return;
    }
  x1 -= FIRST;
  if (!x2 && x1 >= 0 && x1 < DIM)
    {
      struct hang *h = &m->m_hang[x1];
      if (h->h_trans) 
	{
	  long del = (gettime() - h->h_time) >> 3;
	  if (del > 255) del = 255;
	  else if (del < 1) del = 1;
	  h->h_trans->t_length = del;
	  h->h_trans = 0;
	}
      return;
    }
  if (x2 && m->m_firstpit < 0)
    {
      m->m_firstpit = x1;
      m->m_firsttrans.t_vel = x2;
      m->m_firsttrans.t_length = 64;
      m->m_hang[x1].h_time = gettime();
      m->m_hang[x1].h_trans = &m->m_firsttrans;
    }
  else if (x2 && x1 >= 0 && x1 < DIM && lastrec >= 0 && lastrec < DIM
	   && (timediff = gettime() - m->m_rectime) < m->m_val)
    {
      struct trans *t = &(*m->m_matrix)[lastrec*COLS + x1];	
      /* save up to GOO old transitions for repeated notes */
      if (x1 == lastrec)
	{
	  int phase = m->m_goophase[lastrec];
	  struct trans *t2 = &(*m->m_matrix)[lastrec*COLS +
					     DIM + phase];
	  *t2 = *t;
	  m->m_goophase[lastrec] = (phase + 1) & (GOO-1);
	}
      t->t_vel = x2;
      t->t_length = 64;
      if (timediff < m->m_maxdiff) timediff = 0;
      t->t_inter = timediff;
      m->m_hang[x1].h_time = gettime();
      m->m_hang[x1].h_trans = t;
    }
  if (x2)
    {
      m->m_recpit = x1;
      m->m_rectime = gettime();
    }
}

void jimbob_print(struct jimbob *m)
{
  post("record %ld time %ld", (long)m->m_recpit, m->m_rectime);
  post("val %ld", m->m_val);
  post("maxdiff %ld", m->m_maxdiff);
}

void jimbob_clear(struct jimbob *m)
{
  int i, j;
  struct trans *tp;
  
  m->m_record = 0;
  for (i=0; i<DIM; i++) for (j = COLS, tp=(*m->m_matrix) + i*COLS; j--; tp++)
    tp->t_vel = 0;
  for (i=0; i<DIM; i++) m->m_hang[i].h_trans = 0, m->m_goophase[i] = 0;
  m->m_playtrans = 0;
  m->m_playpit = 0;
  m->m_recpit = -1;
  m->m_firstpit = -1;
  clock_unset(m->m_clock);
}

void jimbob_record(struct jimbob *m)
{
  m->m_record = 1;
}

void jimbob_stoprec(struct jimbob *m)
{
  m->m_record = 0;
}

void jimbob_bang(struct jimbob *m)
{
  if (m->m_firstpit < 0)
    {
      post("jimbob: no sequence");
      return;
    }
  m->m_playpit = m->m_firstpit;
  m->m_playtrans = &m->m_firsttrans;
  clock_set(m->m_clock, gettime());
}

void jimbob_tick(struct jimbob *m)
{
  long x, r, index;
  int i, row, lastplay, ncolumn;
  struct trans *tp;
  
  x = 0;
  r = randi();
  ncolumn = (m->m_repeat ? COLS : DIM);
  outlet_int(m->m_durout, (m->m_playtrans->t_length & 0xffL)<<3);
  outlet_int(m->m_velout, m->m_playtrans->t_vel & 0xffL);
  outlet_int(m->m_ob.o_outlet, (long)m->m_playpit + FIRST);
  row = m->m_playpit;
  for (tp = (*m->m_matrix) + COLS * row, i=ncolumn; i--; tp++)
    x += tp->t_vel;
  /* post("%ld->%ld", (long)row, x); */
  if (!x)				/* if nowhere to go stop */
    {
      if (m->m_restart)
	{
	  if (m->m_firstpit < 0)
	    {
	      post("jimbob: no sequence");
	      return;
	    }
	  m->m_playpit = m->m_firstpit;
	  m->m_playtrans = &m->m_firsttrans;
	  clock_set(m->m_clock, gettime() + 500L);
	}
      return;
    }
  index = (r * x) >> 15;
  if (!index) index++;
  for (tp = (*m->m_matrix) + COLS * row, i=0; i < ncolumn; tp++, i++)
    {
      index -= tp->t_vel;
      if (index <= 0) break;
    }
  if (i >= ncolumn) post("fuck"), i--;
  m->m_playtrans = (*m->m_matrix) + COLS * row + i;
  m->m_playpit = (i >= DIM ? row:i);
  if (m->m_playtrans->t_inter < 5) m->m_chordlength++;
  else m->m_chordlength = 0;
  if (m->m_chordlength > 50) clock_set(m->m_clock, gettime() + 500L);
  else clock_set(m->m_clock, gettime() + (long)(m->m_playtrans->t_inter));
}

void jimbob_stop(struct jimbob *m)
{
  clock_unset(m->m_clock);
}

void jimbob_set(struct jimbob *m, long int n)
{
  m->m_val = n;
}

void jimbob_in1(struct jimbob *m, long int n)
{
  m->m_inval = n;
}

void jimbob_restart(struct jimbob *m, long int n)
{
  m->m_restart = n;
}

void jimbob_r(struct jimbob *m, long int n)
{
  m->m_repeat = n;
}

void jimbob_maxdiff(struct jimbob *m, long int n)
{
  m->m_maxdiff = n;
}

void jimbob_ff(struct jimbob *m)
{
  clock_free(m->m_clock);
  t_disposehandle((void **)(m->m_matrix));
}

t_externclass *jimbob_class;

void *jimbob_new(void)
{
  struct jimbob *m;
  int i, j;
  struct trans *tp;
  
  m = (struct jimbob *)obj_new(&jimbob_class, 0);
  if (!(m->m_matrix = (struct trans **)
	t_newhandle((sizeof(struct trans) * (long)DIM * (long) COLS))))
    {
      post("jimbob: not enough memory");
      return (0);
    }
  m->m_clock = clock_new(m, jimbob_tick);
	inlet_new(m, m, gensym("int"), gensym("in1"));
  m->m_durout = outlet_new(m, gensym("int"));
  m->m_velout = outlet_new(m, gensym("int"));
  outlet_new(m, gensym("int"));
  m->m_restart = 0;
  jimbob_clear(m);
  m->m_val = 2000;
  m->m_maxdiff = 50;
  m->m_inval = 0;
  m->m_repeat = 0;
  m->m_chordlength = 0;
  return (m);
}


void jimbob_setup(void)
{
	c_extern(&jimbob_class, jimbob_new, jimbob_ff, gensym("jimbob"),
		sizeof(t_jimbob), 0, 0);
  c_addbang(jimbob_bang);
  c_addint(jimbob_int);
  c_addmess(jimbob_in1, gensym("in1"), A_LONG, 0);
  c_addmess(jimbob_print, gensym("print"), 0);
  c_addmess(jimbob_clear, gensym("clear"), 0);
  c_addmess(jimbob_record, gensym("record"), 0);
  c_addmess(jimbob_stoprec, gensym("stoprec"), 0);
  c_addmess(jimbob_stop, gensym("stop"), 0);
  c_addmess(jimbob_set, gensym("set"), A_LONG, 0);
  c_addmess(jimbob_maxdiff, gensym("maxdiff"), A_LONG, 0);
  c_addmess(jimbob_restart, gensym("restart"), A_LONG, 0);
  c_addmess(jimbob_r, gensym("r"), A_LONG, 0);
}

